[![GitHub issues](https://img.shields.io/github/issues/TrainingByPackt/Advanced-JavaScript.svg)](https://github.com/TrainingByPackt/Advanced-JavaScript/issues)
[![GitHub forks](https://img.shields.io/github/forks/TrainingByPackt/Advanced-JavaScript.svg)](https://github.com/TrainingByPackt/Advanced-JavaScript/network)
[![GitHub stars](https://img.shields.io/github/stars/TrainingByPackt/Advanced-JavaScript.svg)](https://github.com/TrainingByPackt/Advanced-JavaScript/stargazers)
[![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg)](https://github.com/TrainingByPackt/Advanced-JavaScript/pulls)

# Advanced JavaScript
In this course, you will gain a deep understanding of JavaScript. You will learn how to write JavaScript in a professional environment using the new JavaScript syntax in ES6, leverage on JavaScript's asynchronous nature using callbacks and promises, and understand how to set up test suites and test your code. You will be introduced to JavaScript's functional programming style and you will apply everything learned to build a simple application in various JavaScript frameworks and libraries for backend and frontend development.

Advanced JavaScript by **Zachary Shute**

## What you will learn
*	Examine major features in ES6 and implement those features to build applications
*   Create promise and callback handlers to work with asynchronous processes
*	Develop asynchronous flows using Promise chaining and async/await syntax
*	Manipulate the DOM with JavaScript
*	Handle JavaScript browser events
*	Explore Test Driven Development and build code tests with JavaScript code testing frameworks.
*	List the benefits and drawbacks of functional programming compared to other styles
*	Construct applications with the Node.js backend framework and the React frontend framework



### Hardware Requirements
For an optimal student experience, we recommend the following hardware configuration:
* **Processor**: Intel Core i5 or equivalent
* **Memory**: 4GB RAM
* **Storage**: 35GB available space

### Software Requirements
You'll also need the following software installed in advance:
* **OS**: Windows 7 SP1 64-bit, Windows 8.1 64-bit or Windows 10 64-bit
* **Browser**: Google Chrome, Latest Version
* **Atom IDE**
* **Babel**
* **Node.js and npm**
